import('./zoom.css')

// 添加自定义缩放控件
export default ({ map, BMapGL, anchor, offset, zoom = 1 }) => {
  //定义一个控件类
  function ZoomControl() {
    this.defaultAnchor = anchor;
    this.defaultOffset = new BMapGL.Size(...offset);
  }
  //通过JavaScript的prototype属性继承于BMap.Control
  ZoomControl.prototype = new BMapGL.Control();

  //自定义控件必须实现自己的initialize方法，并且将控件的DOM元素返回
  //在本方法中创建个div元素作为控件的容器，并将其添加到地图容器中
  ZoomControl.prototype.initialize = function (map) {
    //创建一个dom元素
    var div = document.createElement("div");
    const divADD = document.createElement("div");
    const divSUB = document.createElement("div");
    divADD.innerHTML = "+";
    divSUB.innerHTML = "-";
    //添加文字说明
    div.appendChild(divADD);
    div.appendChild(divSUB);
    // 设置样式
    div.classList.add("custom-zoom-box");
    divADD.classList.add("custom-zoom-control");
    divSUB.classList.add("custom-zoom-control");
    // 绑定事件,点击一次放大两级
    divADD.onclick = function (e) {
      map.setZoom(map.getZoom() + zoom);
    };
    divSUB.onclick = function (e) {
      map.setZoom(map.getZoom() - zoom);
    };
    // 添加DOM元素到地图中
    map.getContainer().appendChild(div);
    // 将DOM元素返回
    return div;
  };

  //创建控件元素
  var myZoomCtrl = new ZoomControl();
  //添加到地图中
  map.addControl(myZoomCtrl);
}
