// 通过当前数据信息，返回地图图标
const iconsMap = new Map();

export default ({ imgs, data, BMapGL }) => {
  let icon = iconsMap.get(data.icon); // 初始化icon
  if (icon) {
    return icon;
  }

  const iconIndex = data.icon;
  if (!imgs || !imgs.length || typeof iconIndex !== "number") {
    // 如果没有传图标图片数组，或者传入的对应数据对应icon不存在，返回百度地图默认icon
    return null;
  }
  const iconInfo = imgs[iconIndex]; // 对应props里图片信息{ icon, size }
  var myIcon = new BMapGL.Icon(
    iconInfo.icon,
    new BMapGL.Size(...iconInfo.size),
    {
      // ...(iconInfo.imageOffset && { imageOffset: new BMapGL.Size(...iconInfo.imageOffset) }),
      // 设置图片偏移
    }
  );
  const iconSize = new BMapGL.Size(...iconInfo.size);
  myIcon.setImageSize(iconSize);
  myIcon.setSize(iconSize);
  myIcon.setAnchor(new BMapGL.Size(iconInfo.size[0] / 2, iconInfo.size[1])); // 注意设置好图片信息里的size比例
  iconsMap.set(iconIndex, myIcon);

  return myIcon;
};
